module SimplexCommon(
  convertInput,
  SimplexInput,
  Index,
  Variable
  ) where

import qualified SimplexInternals as SI
import Data.Ratio

instance Show SI.Rational where
  show (SI.Div n d) = if d == 1 then show n else show n ++ "/" ++ show d

instance Show SI.Relation where
  show (SI.Ge) = "Ge"
  show (SI.Gt) = "Gt"
  show (SI.Le) = "Le" 
  show (SI.Lt) = "Lt"

type Index = Integer
type Variable = String

-- data SI.Relation = Ge | Gt | Le | Lt
-- greater-equal, greater-than, less-equal, less-than

type SimplexInput = [(Index, [(Rational,Variable)], SI.Relation, Rational)]

convertInput :: SimplexInput -> [SI.Inequality]
convertInput = map (\ (i, linexp, rel, bound) -> SI.Inequality i 
   (map ( \ (c, x) -> (convRat c, x)) linexp) rel (convRat bound))
  where convRat x = SI.Div (numerator x) (denominator x)
