module SimplexInterface(
  SimplexResult(..),
  simplex,
  Relation(..),  
  Index,
  SimplexInput,
  Variable,
  exampleInvocation)
  where

import SimplexInternals
import SimplexCommon

simplex = simplexNonIncremental . convertInput

instance Show SimplexResult where
  show (Sat is) = "Sat " ++ show is
  show (Unsat ass) = "Unsat " ++ show ass

instance Show SimplexState where
  show _ = "<internal SimplexState>" 

exampleInvocation = putStrLn $ "simplex [" ++
   "(1, [(2/3, \"x\"), (-3 / 2, \"y\")], Gt, 4), " ++
   "(2, [(1, \"y\")], Lt, -4), " ++
   "(3, [(1, \"y\")], Ge, 2)]"